close_graph ();;
open_graph " 1000x300-0-64";;

let create_cn n =
  {tab = Array.init n (fun i -> [|if i <= 0 then -1 else i - 1;
				  if i >= n - 1 then -1 else i + 1|]);
   pos = Array.init n (fun i -> (988 - 30 * (i mod 33), 285 - 30 * (i / 33)))
  };;

let bit x n =
  if x = sharp then 0
  else (x lsr n) land 1;;


(* ecrit en binaire le nombre de noeud d'un graphe "chemin" 
   (non teste !)
   couleur : blanc si (bit s 1) = 0
   sinon vert ssi (bit s 3) = 1

   etats initiaux : 1 0 0 ... 0
 *)
let f : tfun =
  fun s [|g;d|] ->
    if g = sharp then
      (1 lsl 0) lor
      (((bit s 2) lor (bit s 0)) lsl 1) lor
      (((bit d 2)) lsl 2) lor
      (((bit s 3) lxor (bit s 4)) lsl 3) lor
      (((bit s 2)) lsl 4)
    else
      (((bit g 0) land (bit g 1)) lsl 0) lor
      (((bit s 1) lor (bit s 0)) lsl 1) lor
      ((((bit s 0) land (lnot (bit s 1))) lor (bit d 2)) lsl 2) lor
      (((bit s 3) lxor (bit s 4)) lsl 3) lor
      (((bit g 3) land (bit g 4)) lsl 4)
;;

let c : colfun = fun i ->
  if (bit i 1) = 0 then 
    white
  else if (bit i 3) = 0 then
    if (bit i 2) = 1 then
      if (bit i 4) = 1 then
	rgb 191 0 63
      else
	rgb 191 0 0
    else if (bit i 4) = 1 then
      rgb 255 0 63
    else
      rgb 255 0 0
  else if (bit i 2) = 1 then
    if (bit i 4) = 1 then
      rgb 0 191 63
    else
      rgb 0 191 0
  else if (bit i 4) = 1 then
    rgb 0 255 63
  else
    rgb 0 255 0;;

let init_state n = 
  let tab = Array.make n 0
  in tab.(0) <- 9; tab;;

let speed = ref (1.0);;

let run n = 
  let graph = create_cn n
  and status = ref ([|0|])
  and new_status = ref (init_state n)
  in 
    draw_first graph c !new_status;
    while (!status <> !new_status) do
      begin
	status := !new_status;
	if (!speed = 0.0) then (read_line (); ())
	else mysleep !speed;
	new_status := draw_step graph f c !status
      end
    done;;

    
