open Printf;;

close_graph ();;
                    (* +---------------------------------+
                       |  open_graph " 1000x300-0-64";;  |
                       +---------------------------------+ *)

#use "cella2.ml";;

let create_cn n =
  {tab = Array.init n (fun i -> [|if i <= 0 then -1 else i - 1;
				  if i >= n - 1 then -1 else i + 1|]);
   pos = Array.init n (fun i -> (988 - 30 * (i mod 33), 285 - 30 * (i / 33)))
  };;

let bit x n =
  if x = sharp then 0
  else (x lsr n) land 1;;


(* ecrit en binaire le nombre de noeud d'un graphe "chemin" 
   (non teste !)
   couleur : blanc si (bit s 1) = 0
   sinon vert ssi (bit s 3) = 1

   etats initiaux : 1 0 0 ... 0
 *)
let f : tfun =
  fun s [|g;d|] ->
    if g = sharp then
      (0 lsl 0) lor
      ((bit d 1) lsl 1) lor
      ((bit d 1) lsl 2) lor
      (((bit s 3) lxor (bit s 2)) lsl 3)
    else
      ((bit g 0) lsl 0) lor
      (((bit g 0) lor (bit d 1)) lsl 1) lor
      (((bit g 3) land (bit g 2)) lsl 2) lor
      (((bit s 3) lxor (bit s 2)) lsl 3)
;;

let c : colfun = fun i ->
  rgb
    (if (bit i 3) = 1 then 0
     else if (bit i 2) = 1 then 191
     else 255)
    (if (bit i 3) = 0 then 0
     else if (bit i 2) = 1 then 191
     else 255)
    (if (bit i 0) = 1 then
       if (bit i 1) = 1 then 191
       else 127
     else if (bit i 1) = 1 then 127
     else 0)
;;

let print_status status =
  for i = 0 to 3 do
    begin
      for j = (Array.length status) -1 downto 0 do 
	printf "%d" (bit status.(j) i)
      done;
      printf "\n"
    end
  done;;

let init_status n = 
  let tab = Array.make n 0
  in tab.(0) <- 9; tab;;

let speed = ref (0.0);;

let run n = 
  let (step, stop) = stepper (create_cn n) f (init_status n)
  and cpt = ref (-1)
  in 
    begin
      print_status (init_status n);
      while not !stop do
	begin
	  read_line ();
	  print_status (step ());
	  cpt := !cpt + 1
	end
      done;
      printf "<%d> transitions.\n" !cpt
    end;;
    
