open Graph
open Graphics
open Gdrawing


type tfun = int -> int array -> int
type colfun = int -> color

let step g (f:tfun) status =
  Array.mapi
    (fun i s -> f status.(i) (Array.map
				(fun v -> if v = sharp then sharp else status.(v))
				(nboors g i)))
    status

let draw_first g (c:colfun) status =
  draw g (Array.map c status)

let draw_step g f (c:colfun) status =
  let new_status = step g f status
  in 
    draw_nodes g (Array.map c new_status);
    new_status

