open Graph
open Graphics
open Gdrawing


type tfun = int -> int array -> int
type colfun = int -> color

let xchg r1 r2 =
  let tmp = !r1 in r1 := !r2; r2 := tmp

let stepper g (f:tfun) init =
  let graph = tab g
  and nbs = Array.copy ((tab g).(0))
  and old = ref (Array.copy init)
  and cur = ref (Array.copy init)
  and eqs = ref false
  in ((fun () ->
	 xchg old cur;
	 eqs := true;
	 Array.iteri
	   (fun i s ->
	      try
		begin
		  Array.iteri
		    (fun j v ->
		       try 
			 nbs.(j) <- if v = sharp then v else !old.(v)
		       with Invalid_argument str -> failwith "calcul des tats des voisins")
		    graph.(i);
		  !cur.(i) <- f s nbs;
		  eqs := !eqs && (!cur.(i) = !old.(i))
		end
	      with Invalid_argument str -> failwith "calcul d'un nouvel tat")
	   !old;
	 !cur),
      eqs)
      

