open Graphics
open Graph
open Gio

let draw_node n x y color =
  let (w,h) = text_size (string_of_int n)
  in let r = int_of_float (ceil ((sqrt (((float_of_int w) /. 2.) ** 2. +.
					  ((float_of_int h) /. 2.) ** 2.)) +. 1.))
  in 
    set_color color;
    fill_circle x y r;
    set_color foreground;
    moveto (x - w / 2) (y - h / 2);
    draw_string (string_of_int n);
    draw_circle x y r

let my_line (x1,y1) (x2,y2) =
  moveto x1 y1;
  lineto x2 y2 

let draw_edges graph =
  Array.iteri
    (fun i nbs ->
       Array.iter
	 (fun v ->
	    if i < v then my_line (pos graph).(i) (pos graph).(v))
	 nbs)
    (tab graph)

let draw_nodes graph colors =
  Array.iteri
    (fun i (x,y) -> draw_node i x y colors.(i))
    (pos graph)

let draw graph colors =
  clear_graph ();
  draw_edges graph;
  draw_nodes graph colors

let redraw graph colors =
  recomputepos graph;
  draw graph colors
