{
  open Lexing 
  open Gparser 
}


rule enext_token =
   parse 
       [ ' ' '\t' '\n' ] +  { enext_token lexbuf }
     | '.'                  { End }
     | ';'                  { SemiColon }
     | '-'                  { Edge }
     | [ '0' - '9' ] +      { Int (int_of_string (lexeme lexbuf)) }
and rnext_token =
   parse
       eof { Eof }
     | [ ' ' '\t' ] +  { rnext_token lexbuf }
     | '\n'            { Newline }
     | '#'             { Int (Graph.sharp) }
     | ['0'-'9'] +     { Int (int_of_string (lexeme lexbuf)) }
