
%{
  open Graph

  let n = ref (0)
  and d = ref (0)
  and tab_of_list size def l =
    let tab = Array.make size def 
    and i = ref (0)
    in 
      begin
	List.iter (fun x -> tab.(!i) <- x; i := !i + 1) l;
	tab
      end

%}

%token Edge SemiColon End Eof Newline
%token < int > Int

%start edge_list raw_graph
%type < (int * int) list > edge_list
%type < Graph.graph > raw_graph

%%

edge_list : Int Edge Int End       { [($1,$3)] }
          | Int Edge Int SemiColon edge_list { ($1, $3) :: $5 }


raw_graph : header line_list { Graph.make (tab_of_list 
					     !n 
					     (Array.make !d sharp)
                                             $2)
			     }

header : Int Int Newline { n := $1; d := $2 }

line_list : Eof            { [] }
          | line line_list { match $1 with
				 [] -> $2
			       | l  -> (tab_of_list !d sharp $1) :: $2
			   }

line : Newline   { [] }
     | Int line  { $1 :: $2 }


%%
